% -------------------------------------------------------------
% Used to produce Figure 1 in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
t=   [-1,0,0.001,1,1.001, 2,2.001, 3,3.001,4,5,5.001, 6, 7,7.001,8,9,9.001,10,11,11.001,12,12.001,13,14];
zerl=[ 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0];
chi1=[ 0,0,    1,1,   -1,-1, 0, 0,    0,0,0,    0, 0, 0,    0,0,0,    0, 0, 0,     0, 0,     0, 0, 0];
chi6=[ 0,0,    1,1,   -1,-1,-1,-1,    1,1,1,   -1,-1,-1,    1,1,1,   -1,-1,-1,     1, 1,     0, 0, 0];
plot(t,zerl,':k','LineWidth',1);
hold on;
plot(t,chi1,'-k','LineWidth',2);
axis([-1 13.5 -1.2 1.2]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[-1,0,1]);
set(gca,'xTick',[0,2,4,6,8,10,12]);
