% -------------------------------------------------------------
% Used to produce Figure 10 in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
r=linspace(0.001,11,1000);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
s1r=hr.*(1-zr/2)-h0r;
plot(r,r.*s1r,'-k','LineWidth',2);
hold on;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
n=2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(r,r.*snr,'-k','LineWidth',1);
hold on;
n=3;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(r,r.*snr,'-k','LineWidth',1);
hold on;
n=4;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(r,r.*snr,'-k','LineWidth',1);
hold on;
n=5;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(r,r.*snr,'-k','LineWidth',1);
hold on;
n=1000;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(r,r.*snr,'-k','LineWidth',2);
hold on;
axis([0 11 0 1]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[0.2,0.4,0.6,0.8]);
set(gca,'xTick',[2,4,6,8,10]);

