% -------------------------------------------------------------
% Used to produce Figure 12 (bottom) in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
n = linspace(1,1000,1000);
tc = 0.02;
nodd = 2*n-4*floor(n/2)-1;
r2 = .5;
k = 0.01;

wc = 20;

rho = 0.1;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',2);
hold on;

rho = 0.2;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',1);
hold on;

rho = 0.23;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',1);
hold on;

rho = 0.24;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',1);
hold on;

rho = 0.245;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*exp(-wc*rho*taun.*real(snr)),':k','LineWidth',1);
hold on;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',2);
hold on;

rho = 0.2475;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*exp(-wc*rho*taun.*real(snr)),':k','LineWidth',1);
hold on;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',1);
hold on;

rho = 0.25;
tau = rho*tc;
r=complex(k,1)*2*3.14159265*rho;
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
taun = 2*tau*n;
plot(taun,exp(-taun*r2).*exp(-wc*rho*taun.*real(snr)),':k','LineWidth',1);
hold on;
plot(taun,exp(-taun*r2).*besselj(0,sqrt(4*wc*rho*taun.*real(snr))),'-k','LineWidth',1);
hold on;

plot(taun,0*taun,'--k','LineWidth',1);
hold on;

set(gca,'FontSize',20);
set(gca,'LineWidth',2);
%set(gca,'yScale','log');
axis([0 4 -.2 1]);
set(gca,'yTick',[-0.2,0,0.2,0.4,0.6,0.8]);
set(gca,'xTick',[1,2,3]);
