% -------------------------------------------------------------
% Used to produce Figure 4 in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
t=linspace(0.1,60,500);
sfr=2*(1-(1-exp(-t))./t);
plot(t,sfr,':k','LineWidth',1);
hold on;
n=1;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',2);
hold on;
n=2;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',1);
hold on;
n=3;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',1);
hold on;
n=4;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',1);
hold on;
n=5;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',1);
hold on;
n=10;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',2);
hold on;
n=20;
r=t/(2*n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(t,t.*snr/n,'-k','LineWidth',1);
hold on;
axis([0 50 0 2.1]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[0.5,1,1.5,2]);
set(gca,'xTick',[10,20,30,40]);

