% -------------------------------------------------------------
% Used to produce Figure 5 (top) in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
rho=linspace(0.001,5,2000);
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
n=1;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(rho,real(snr)/n,':k','LineWidth',1);
hold on;
n=2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(rho,real(snr)/n,'-k','LineWidth',1);
hold on;
n=3;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(rho,real(snr)/n,'-k','LineWidth',2);
hold on;
n=10;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
%plot(rho,real(snr)/n,'-k','LineWidth',2);
hold on;
axis([0 2.1 0 0.6]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[0.1,0.2,0.3,0.4,0.5]);
set(gca,'xTick',[0.5,1,1.5,2]);

