% -------------------------------------------------------------
% Used to produce Figure 6 (bottom) in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
t=linspace(0.1,62,2000);

n=10;
r=complex(0,3.14159265*t/n);
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onemz2n=(1-exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onemz2n)./z2plus1-h0r;
plot(t,t.*t.*snr/n,'-k','LineWidth',2);
hold on;

axis([0 62 0 11]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[2,4,6,8,10]);
set(gca,'xTick',[20,40,60]);

