% -------------------------------------------------------------
% Used to produce Figure 7 (top) in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
n = linspace(1,200,200);
nodd = 2*n-4*floor(n/2)-1;

rho = 0.168;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',1);
hold on;

rho = 0.2;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',1);
hold on;

rho = 0.23;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',2);
hold on;

rho = 0.24;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',1);
hold on;

rho = 0.245;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',1);
hold on;

rho = 0.2475;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',2);
hold on;

rho = 0.2499;
r=complex(0,2*3.14159265*rho);
zr=exp(-r);
gr=(1-exp(-r))/r;
gmr=(exp(r)-1)/r;
hr=(gmr-gr)/r;
h0r=(gmr-1)/r;
z2plus1=zr*zr+1;
nonfac=(zr*(1-zr)*(1-zr)/z2plus1)/2;
onez2n=(1+nodd.*exp(-2*r*n))./n;
snr=(hr*(1-nonfac*onez2n)/z2plus1-h0r)./n;
plot(n,4*rho*rho*n.*n.*real(snr),'-k','LineWidth',1);
hold on;

set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yScale','log');
axis([0 120 0.05 2000]);
set(gca,'yTick',[0.1,1,10,100,1000]);
set(gca,'xTick',[20,40,60,80,100]);

