% -------------------------------------------------------------
% Used to produce Figure 8 (top) in the article
% Field noise effects on NMR signals: Hahn echoes and CPMG,
% by S.Sykora, published in Stan's Library, Volume I, 2006.
% URL: www.ebyte.it/library
% -------------------------------------------------------------
clear;clc;clf;echo on;
t=linspace(0.1,125,2000);
n=1;
k=0.005
r=complex(k,1)*3.14159265*t/n;
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(t,t.*t.*snr/n,'-k','LineWidth',1);
hold on;

k=0.05
r=complex(k,1)*3.14159265*t/n;
zr=exp(-r);
gr=(1-exp(-r))./r;
gmr=(exp(r)-1)./r;
hr=(gmr-gr)./r;
h0r=(gmr-1)./r;
z2plus1=zr.*zr+1;
nonfac=(zr.*(1-zr).*(1-zr)./z2plus1)/2;
onepz2n=(1+exp(-2*n*r))/n;
snr=hr.*(1-nonfac.*onepz2n)./z2plus1-h0r;
plot(t,t.*t.*snr/n,'-k','LineWidth',2);
hold on;

axis([0 62 0 1.2]);
set(gca,'FontSize',20);
set(gca,'LineWidth',2);
set(gca,'yTick',[0.2,0.4,0.6,0.8,1]);
set(gca,'xTick',[20,40,60]);

